#include <X11/Xlib.h>

#define WIN_W     400  /* ɥ   */
#define WIN_H     300  /* ɥι⤵ */
#define WIN_X     100  /* ɥɽ(X) */
#define WIN_Y     100  /* ɥɽ(Y) */
#define BORDER    2    /* ܡ      */
#define BOX_W     200  /* 褹Ĺ */
#define BOX_H     100  /* ⤵ */
#define BOX_X     50   /* Ѥ X ɸ */
#define BOX_Y     50   /* Ѥ Y ɸ */
#define CIRCLE_W  100  /* ߤܤ */
#define CIRCLE_H  100  /* ߤܤι⤵ */
#define CIRCLE_X  200  /* ߤ濴 X ɸ */
#define CIRCLE_Y  180  /* ߤ濴 Y ɸ */


static void draw( Display* dpy, Window win, GC gc, 
  unsigned long green, unsigned long red );


int 
main( void )
{
	Display*       dpy;         /* ǥץ쥤 */
	Window         root;        /* 롼ȥɥ */
	Window         win;         /* ɽ륦ɥ */
	int            screen;      /* ꡼ */
	unsigned long  black,white; /* Υԥ */
	GC             gc;          /* եåƥ */
	XEvent         evt;         /* ٥ȹ¤ */

	Colormap       cmap;        /* 顼ޥå */
	XColor         color, exact;
	unsigned long  green, red;  /* Ф֤Υԥ */


	/* XФ³ */
	dpy = XOpenDisplay( "" );


	/* ǥץ쥤ѿμ */
	root   = DefaultRootWindow( dpy );
	screen = DefaultScreen( dpy );


	/* XAllocNamedColor() Τ˥顼ޥåפ */
	cmap   = DefaultColormap( dpy, screen ); 


	/* 򡢹Υԥͤ */
	white  = WhitePixel( dpy, screen );
	black  = BlackPixel( dpy, screen );


	/* Ф֤Υԥͤ */
	XAllocNamedColor( dpy, cmap, "green", &color, &exact );
	green = color.pixel;

	XAllocNamedColor( dpy, cmap, "red", &color, &exact );
	red = color.pixel;


	/* ɥ롣λǤϤޤ̤ɽʤ*/
	win = XCreateSimpleWindow( dpy, root,
		   WIN_X, WIN_Y, WIN_W, WIN_H, BORDER, black, white);


	/* եåƥȤ */
	gc = XCreateGC( dpy, win, 0, NULL );


	/* XФΤƤ餦٥Ȥ
	   Ǥϥ٥Ȥ¾ Expose ٥Ȥ򤷤Ƥ */
	XSelectInput( dpy, win, KeyPressMask | ExposureMask );


	/* ɥ̤ɽ(ޥåפ) */
	XMapWindow( dpy, win );


	/* XФ饤٥Ȥɤ߹ǿƤ٥ȥ롼 */
	while( 1 ) {
		XNextEvent( dpy, &evt );

		switch( evt.type ) {
			case Expose:      
				if ( evt.xexpose.count == 0 ) {
					draw( dpy, win, gc, green, red );
				}
				break;

			case KeyPress:
				/* ꥽β */
				XFreeGC( dpy, gc );
				XDestroyWindow( dpy, win );
				XCloseDisplay( dpy );
				return 0;
		}
	}
}


static void
draw( Display* dpy, Window win, GC gc, 
      unsigned long green, unsigned long red )
{
	/* 迧֤ */
	XSetForeground( dpy, gc, red );

	/* ͳѷ */
	XFillRectangle( dpy, win, gc, BOX_X, BOX_Y, BOX_W, BOX_H );

	/* 迧Ф */
	XSetForeground( dpy, gc, green );

	/* ߤ */
	XFillArc( dpy, win, gc, 
		  CIRCLE_X, CIRCLE_Y, CIRCLE_W, CIRCLE_H, 
		  0, 360 * 64 );
}


/* End of xgraphics.c */
