#include <X11/Xlib.h> 
#include <X11/Xutil.h>  /* for XTextProperty */
#include <X11/Xatom.h>  /* for XA_STRING     */
#include <string.h>


#define WIN_W   400  /* ɥ   */
#define WIN_H   300  /* ɥι⤵ */
#define WIN_X   100  /* ɥɽ(X) */
#define WIN_Y   100  /* ɥɽ(Y) */
#define BORDER  2    /* ܡ      */


int 
main( int argc, char** argv )
{
	Display*       dpy;          /* ǥץ쥤 */
	Window         root;         /* 롼ȥɥ */
	Window         win;          /* ɽ륦ɥ */
	int            screen;       /* ꡼ */
	unsigned long  black, white; /* Υԥ */
	XEvent         evt;
	XTextProperty  w_name;       /* ɥ̾ʤɤꤹ */

	dpy = XOpenDisplay( "" );

	root   = DefaultRootWindow( dpy );
	screen = DefaultScreen( dpy );
	white  = WhitePixel( dpy, screen );
	black  = BlackPixel( dpy, screen );

	win = XCreateSimpleWindow( dpy, root,
		   WIN_X, WIN_Y, WIN_W, WIN_H, BORDER, black, white );

	/* ɥ̾λ */
	w_name.value    = (unsigned char*)"Sample program!";
	w_name.encoding = XA_STRING;
	w_name.format   = 8;
	w_name.nitems   = strlen( "Sample program!" );

	/* ɥޥ͡˾Τ */
	XSetWMProperties( dpy, win, &w_name, NULL, argv, argc, NULL, NULL, NULL );

	XSelectInput( dpy, win, KeyPressMask );
	XMapWindow( dpy, win );

	while( 1 ) {
		XNextEvent( dpy, &evt );
      
		switch ( evt.type ) {
			case KeyPress :
				/* ꥽β */
				XDestroyWindow( dpy, win );
				XCloseDisplay( dpy );
				return 0;
		}
	}
}

/* End of xwm.c */
